###################################################
### chunk number 1: 
###################################################
library(Rcapture)
data(hare)
desc<-descriptive(hare)
plot(desc)
closedp(hare)


###################################################
### chunk number 2: 
###################################################
plot(desc)


###################################################
### chunk number 3: 
###################################################
col<-rep(0,2^6-1)
mat<-histpos.t(6)
col[apply(mat,1,sum)==6]<-1
cp.m2<-closedp.mX(hare,mX=cbind(mat,col),mname="Mt without 111111")
cp.m2$results


###################################################
### chunk number 4: 
###################################################
CI1<-profileCI(hare,m="Mth",h="Poisson",a=2)
CI1$results
CI2<-profileCI(hare,mX=cbind(mat,col),mname="Mt without 111111")
CI2$results


###################################################
### chunk number 5: 
###################################################
data(HIV)
descriptive(HIV,dfreq=TRUE)


###################################################
### chunk number 6: 
###################################################
desc<-descriptive(HIV,dfreq=TRUE)
plot(desc)


###################################################
### chunk number 7: 
###################################################
mat<-histpos.t(4)
mX1<-cbind(mat,mat[,1]*mat[,2],mat[,1]*mat[,3],mat[,1]*mat[,4],mat[,2]*mat[,3],mat[,2]*mat[,4],mat[,3]*mat[,4])
cp.m1<-closedp.mX(HIV,dfreq=TRUE,mX=mX1,mname="Mt double interactions")
cp.m1$results


###################################################
### chunk number 8: 
###################################################
summary(cp.m1$glm)$coefficients


###################################################
### chunk number 9: 
###################################################
mX2<-cbind(mat,mat[,1]*mat[,2])
cp.m2<-closedp.mX(HIV,dfreq=TRUE,mX=mX2,mname="Mt interaction 1,2")
cp.m2$results
CI<-profileCI(HIV,dfreq=TRUE,mX=mX2,mname="Mt interaction 1,2")
CI$results


###################################################
### chunk number 10: 
###################################################
CI<-profileCI(HIV,dfreq=TRUE,mX=mX2,mname="Mt interaction 1,2")


###################################################
### chunk number 11: 
###################################################
data(mvole)
cp<-closedp(mvole[,11:15])
cp


###################################################
### chunk number 12: 
###################################################
psi<-function(x){-log(3.5+x)+log(3.5)}
lgmodel<-closedp.h(mvole[,11:15],h=psi)
lgmodel$results


###################################################
### chunk number 13: 
###################################################
xx<-uifit(cp)
xx$predicted[,c(1,4,5,6)]


###################################################
### chunk number 14: 
###################################################
boxplot(cp)


###################################################
### chunk number 15: 
###################################################
data(bunting)
descriptive(bunting,dfreq=TRUE)


###################################################
### chunk number 16: 
###################################################
op.m1<-openp(bunting,dfreq=TRUE)
op.m1$model.fit[1,]
plot(op.m1)


###################################################
### chunk number 17: 
###################################################
plot(op.m1)


###################################################
### chunk number 18: 
###################################################
keep2<-apply(histpos.t(8),1,sum)>1
op.m2<- openp(bunting,dfreq=TRUE,keep=keep2)
op.m2$model.fit[1,]


###################################################
### chunk number 19: 
###################################################
keep3p<-residuals(op.m2$glm,type="pearson")<4
num3<-((1:255)[keep2])[keep3p]
keep3<-rep(FALSE,255)
keep3[num3]<-TRUE
op.m3<- openp(bunting,dfreq=TRUE,keep=keep3)
tab<-data.frame(op.m2$survivals,rep("|",7),op.m3$survivals)
colnames(tab)<-c("estimate.m2","stderr.m2","|","estimate.m3","stderr.m3")
tab


###################################################
### chunk number 20: 
###################################################
siginv<-solve(op.m2$cov[8:12,8:12])
phi<-t(rep(1,5))%*%siginv%*%op.m2$survivals[2:6,1]/(t(rep(1,5))%*%siginv%*%rep(1,5))
se<-1/sqrt(t(rep(1,5))%*%siginv%*%rep(1,5))
data.frame(estimate=phi,stderr=se,row.names="Common survival: ")


###################################################
### chunk number 21: 
###################################################
chisq4<-t(op.m2$survivals[2:6,1]-phi*rep(1,5))%*%siginv%*%(op.m2$survivals[2:6,1]-phi*rep(1,5))
data.frame(stat=chisq4,pvalue=1-pchisq(chisq4,df=4),row.names="Chi-square test: ")


###################################################
### chunk number 22: 
###################################################
data(duck)
op.m1<-openp(duck,dfreq=TRUE)
op.m1$model.fit[1,]
plot(op.m1)


###################################################
### chunk number 23: 
###################################################
plot(op.m1)


###################################################
### chunk number 24: 
###################################################
1-pchisq(op.m1$model.fit[1,1],df=49)


###################################################
### chunk number 25: 
###################################################
keep2<-apply(histpos.t(6),1,sum)!=6
op.m2<-openp(duck,dfreq=TRUE,keep=keep2)
op.m2$model.fit[1,]
1-pchisq(op.m2$model.fit[1,1],df=48)


###################################################
### chunk number 26: 
###################################################
keep3<-apply(histpos.t(6),1,sum)<5
op.m3<-openp(duck,dfreq=TRUE,keep=keep3)
op.m3$model.fit[1,]
1-pchisq(op.m3$model.fit[1,1],df=42)


###################################################
### chunk number 27: 
###################################################
op.m4<-openp(duck,dfreq=TRUE,keep=keep3,m="ep")
op.m4$model.fit[1,]


###################################################
### chunk number 28: 
###################################################
op.m3$N


###################################################
### chunk number 29: 
###################################################
growth<-op.m3$N[3:5,1]/op.m3$N[2:4,1]
partial<-matrix(c(-op.m3$N[3,1]/op.m3$N[2,1]^2,1/op.m3$N[2,1],0,0,
0,-op.m3$N[4,1]/op.m3$N[3,1]^2,1/op.m3$N[3,1],0,
0,0,-op.m3$N[5,1]/op.m3$N[4,1]^2,1/op.m3$N[4,1]),3,4,byrow=TRUE)
sig<-partial%*%op.m3$cov[9:12,9:12]%*%t(partial)
cbind(estimate=growth,stderr=sqrt(diag(sig)))


###################################################
### chunk number 30: 
###################################################
siginv<-solve(sig)
growth.e<-t(rep(1,3))%*%siginv%*%growth/(t(rep(1,3))%*%siginv%*%rep(1,3))
se<-1/sqrt(t(rep(1,3))%*%siginv%*%rep(1,3))
data.frame(estimate=growth.e,stderr=se,row.names="Common growth rate: ")


###################################################
### chunk number 31: 
###################################################
chisq2<-t(growth-growth.e*rep(1,3))%*%siginv%*%(growth-growth.e*rep(1,3))
data.frame(stat=chisq2,pvalue=1-pchisq(chisq2,df=2),row.names="Chi-square test: ")


###################################################
### chunk number 32: 
###################################################
data(hare)
keep<-rep(TRUE,2^6-1)
mat<-histpos.t(6)
keep[apply(mat,1,sum)==6]<-FALSE
op<-openp(hare,keep=keep)
op$model.fit[1,]


###################################################
### chunk number 33: 
###################################################
data(mvole)
mvole.op<-periodhist(mvole,vt=rep(5,6))
op.m1<-openp(mvole.op,dfreq=TRUE)


###################################################
### chunk number 34: 
###################################################
keep2<-residuals(op.m1$glm,type="pearson")<4
op.m2<-openp(mvole.op,dfreq=TRUE,keep=keep2)
op.m2$model.fit


###################################################
### chunk number 35: 
###################################################
rd.m1<-robustd.0(mvole[,-10], vt=c(5,4,rep(5,4)),vm="Mh",vh="Chao")
rd.m1$model.fit
rd.m1$emig.fit


###################################################
### chunk number 36: 
###################################################
rd.m1$emig.param


###################################################
### chunk number 37: 
###################################################
rd.m2<-robustd.0(mvole[,-10], vt=c(5,4,rep(5,4)),vm="Mh",vh="Darroch")
rd.m2$model.fit
rd.m2$emig.fit
rd.m2$emig.param


###################################################
### chunk number 38: 
###################################################
rd.m3<-robustd.0(mvole[,-10], vt=c(5,4,rep(5,4)),vm=c("Mh","none","Mh","Mh","Mh","Mh"),vh="Chao")


###################################################
### chunk number 39: 
###################################################
rd.m4<-robustd.0(mvole[,-10], vt=c(5,4,rep(5,4)),vm="Mh",vh="Poisson",vtheta=1.5)


###################################################
### chunk number 40: 
###################################################
survivals<-data.frame(op.m1$survivals,rep("|",5),rd.m4$survivals)
N<-data.frame(op.m1$N,rep("|",6),rd.m4$N)
birth<-data.frame(op.m1$birth,rep("|",5),rd.m4$birth)
Ntot<-data.frame(op.m1$Ntot,c("|"),rd.m4$Ntot)
name<-c("estimate.open","stderr.open","|","estimate.robust","stderr.robust")
colnames(survivals)<-colnames(N)<-colnames(birth)<-colnames(Ntot)<- name
survivals
N
birth
Ntot


